import static dit948.SimpleIO.*;
import static dit948.Random.*;


public class  HillRevSol {


    static public int hillLength(int[] x, int start) {
        // if the starting position is outside the
        // range, we return 0
        if (start < 0 || start >= x.length)
            return 0;

        if (x.length - start <= 2) // at most two elements to the end
            return x.length - start;

        boolean goOn = true;

        boolean goingUp;

        if (x[start] <= x[start + 1])
            goingUp = true;
        else
            goingUp = false;

        int i = start + 2;

        do {
            if (x[i-1] < x[i]) 
                if (!goingUp)
                    // we were going down
                    // now we're going up:
                    // we're done!
                    goOn = false;
            if(x[i-1] > x[i])
                goingUp = false;
            if(goOn) {
                i++;
                if (i == x.length)
                    // we're at the end of the array
                    // the hill is as big as the entire array
                    goOn = false;
                
            }
        } while(goOn);

        // the length of the hill is equal to
        // the offset  of the first element after
        // the hill (the last element we looked at)
        // or to the length of the entire rest of
        // the array
        return i - start;
    }

    public static void main(String[] args) {
        int[] emptyArray = new int[0];
        
        println(PrintArraySol.arrayToString(emptyArray) +
                           " starts with a hill of length " +
                           hillLength(emptyArray, 0));

        // test some small arrays, length at most 10
        for (int i = 0; i < 10; i++) {
            int arraySize = randomInt(10) + 1;
            int[] testArray = new int[arraySize];
            for (int j = 0; j < arraySize; j++)
                testArray[j] = randomInt(100) - 50;
            int start = randomInt(arraySize);
            println(PrintArraySol.arrayToString(testArray) +
                               " has from position " + start + " a hill" +
                               " of length " + hillLength(testArray, start));
        }
    }
}
