import static dit948.SimpleIO.*;
import static dit948.Random.*;


public class  HillSol {


    static public int hillLength(int[] x) {
        if (x.length <= 2)
            return x.length;

        boolean goOn = true;

        boolean goingUp;

        if (x[0] <= x[1])
            goingUp = true;
        else
            goingUp = false;

        int i = 2;

        do {
            if (x[i-1] < x[i]) 
                if (!goingUp)
                    // we were going down
                    // now we're going up:
                    // we're done!
                    goOn = false;
            if (x[i-1] == x[i])
                goingUp = goingUp;
            if(x[i-1] > x[i])
                goingUp = false;
            if(goOn) {
                i++;
                if (i == x.length)
                    // we're at the end of the array
                    // the hill is as big as the entire array
                    goOn = false;
                
            }
        } while(goOn);

        // the length of the hill is equal to
        // the index of the first element after
        // the hill (the last element we looked at)
        // or to the length of the entire array
        return i;
    }

    public static void main(String[] args) {
        int[] emptyArray = new int[0];
        
        println(PrintArraySol.arrayToString(emptyArray) +
                           " starts with a hill of length " +
                           hillLength(emptyArray));

        // test some small arrays, length at most 10
        for (int i = 0; i < 10; i++) {
            int arraySize = randomInt(10) + 1;
            int[] testArray = new int[arraySize];
            for (int j = 0; j < arraySize; j++)
                testArray[j] = randomInt(100) - 50;
            println(PrintArraySol.arrayToString(testArray) +
                               " starts with a hill" +
                               " of length " + hillLength(testArray));
        }
    }
}
